Subject: Re: bug#74833: 31.0.50; Copy to OS clipboard doesn't work in macOS Terminal.app with xterm-mouse-mode enabled

From: Filipp Gunbin <[email-masked]>
Date: Fri, 13 Dec 2024 23:32:39 +0300

On 13/12/2024 18:49 +0200, Eli Zaretskii wrote:

>> From: Filipp Gunbin <[email-masked]>
>> Cc: Ship Mints <[email-masked]>,  [email-masked]
>> Date: Fri, 13 Dec 2024 19:35:15 +0300
>>
>> On 13/12/2024 09:21 +0200, Eli Zaretskii wrote:
>>
>> > So why is this an Emacs bug?  It sounds like the OP expects something
>> > to happen which shouldn't, because the xterm protocol for selections
>> > and the clipboard are not supported by Terminal.app?  In that case,
>> > this could be at best a feature request, not a bug.
>>
>> I'll try to explain differently.
>>
>> Without xterm-mouse-mode you can copy/paste from/into Terminal.app
>> window, looks like Terminal.app gives this ability on its own.  This is
>> not integration with Emacs kill ring, no.  Emacs cursor does not react
>> to mouse clicks, and selection happens with OS mouse pointer.  Paste
>> works rather slow (bad idea to paste large chunks of text), but
>> tolerable.
>>
>> Now, yesterday my daily master build got me xterm-mouse-mode enabled, so
>> I did some testing just out of curiosity.  Most of the things work,
>> including clicking and selection.  However, Command-C now just doesn't
>> copy text to OS clipboard.  And it's non-obvious that you should disable
>> xterm-mouse-mode to be able to copy.
>
> xterm-mouse-mode is supposed to be enabled only on terminals that load
> xterm.el, which means they are xterm-compatible.  Does Terminal.app
> load xterm.el on startup?

Terminal.app sets TERM=xterm-256color (this is configurable in "Settings
-> Profiles -> Advanced -> Declare terminal as", I doubt I ever changed
it), so xterm.el should be loaded, yes.

Other term-related vars are:

TERM_PROGRAM=Apple_Terminal
TERM_PROGRAM_VERSION=453
TERM_SESSION_ID=1251C872-8246-4380-A2AE-ED1F8B649878